﻿@using Portal.Models;
@using Portal.Models.DCLReceiving;
@using Portal.Controllers;
@using Portal.Models.PO;
@using System.Web.UI.WebControls;
@using System.Data;
@using System.Data.SqlClient;

@model Toyota.Common.Web.MVC.ModelHolder          

@{Layout = "~/Views/Layout/Dashboard.cshtml";}

@section StartupScript{
@* Set the apps for the startup show form for first time *@
    txtDockCodeInput.SetText('');
    txtDeliveryNo.SetText('');
    txtDockCodeInput.Focus();
    txtArrivalPlan.SetText("");
    txtArrivalActual.SetText("");
    txtDepartureActual.SetText("");
    txtDeparturePlan.SetText("");
    txtDepartureGap.SetText("");
    txtArrivalGap.SetText("");
    document.getElementById("lblRemainingTime").innerHTML = '';
    document.getElementById("lblArrivalInfo").innerHTML = '';
    document.getElementById("lblDepartureInfo").innerHTML = '';
}
<script src="@Url.Content("~/Scripts/soundmanager2.js")" type="text/javascript"></script>
<script type="text/javascript">
    $(document).ready(function () {
        soundManager.setup(
        {
            url: 'Content/swf/soundmanager2.swf',
            onready: function () {
            }
        });
    });

    var DeliveryNo = "";
    var Arrival_Plan_Dt = "";
    var Arrival_Gap = "";
    var Arrival_Actual_Dt = "";
    var Departure_Actual_Dt = "";
    var Departure_Plan_Dt = "";
    var Departure_Gap = "";
    var lblArrivalInfo = "";
    var lblDepartureInfo = "";
    var timer = null;

    //timer for clear truck arrival information every 1 minutes
    

    function ajaxError(request, type, errorThrown) {
        var message = "There was an error with the AJAX request.\n";
        switch (type) {
            case 'timeout':
                message += "The request timed out.";
                break;
            case 'notmodified':
                message += "The request was not modified but was not retrieved from the cache.";
                break;
            case 'parsererror':
                message += "XML/Json format is bad.";
                break;
            default:
                message += "HTTP Error (" + request.status + " " + request.statusText + ").";
        }
        message += "\n";
        document.getElementById("lblErrorMessage").innerHTML = message;
        soundManager.setup(
        {
            url: 'Content/swf/soundmanager2.swf',
            onready: function () {
                var myFailure = soundManager.createSound({
                    id: 'myFailure',
                    url: 'Content/Sounds/Failure.mp3'
                });

                myFailure.play();
            }
        }); 
        txtDeliveryNo.SetText("");
        txtDockCodeInput.SetText("");
        txtDockCodeInput.Focus();
    }

    function ValidateDeliveryData(s, e) {       

        document.getElementById("lblErrorMessage").innerHTML = '';
        
        if (txtDockCodeInput.GetText() == "" || txtDockCodeInput.GetText() == null) {
            document.getElementById("lblErrorMessage").innerHTML = 'Tracking Point required';
            soundManager.setup(
            {
                url: 'Content/swf/soundmanager2.swf',
                onready: function () {
                    var myFailureTP = soundManager.createSound({
                        id: 'myFailureTP',
                        url: 'Content/Sounds/Failure.mp3'
                    });

                    myFailureTP.play();
                }
            });
            txtDeliveryNo.SetText("");
            txtDockCodeInput.SetText("");
            txtDockCodeInput.Focus();
        } else if (txtDeliveryNo.GetText() == "" || txtDeliveryNo.GetText() == null) {
            document.getElementById("lblErrorMessage").innerHTML = 'Delivery No required';
            soundManager.setup(
            {
                url: 'Content/swf/soundmanager2.swf',
                onready: function () {
                    var myFailure = soundManager.createSound({
                        id: 'myFailure',
                        url: 'Content/Sounds/Failure.mp3'
                    });

                    myFailure.play();
                }
            });
            txtDeliveryNo.SetText("");
            txtDockCodeInput.SetText("");
            txtDockCodeInput.Focus();
        }
        else {
            if (txtDeliveryNo.GetText().length < 13) {
                document.getElementById("lblErrorMessage").innerHTML = 'Delivery No is not valid';
                soundManager.setup(
                {
                    url: 'Content/swf/soundmanager2.swf',
                    onready: function () {
                        var myFailure = soundManager.createSound({
                            id: 'myFailure',
                            url: 'Content/Sounds/Failure.mp3'
                        });

                        myFailure.play();
                    }
                });
                txtDeliveryNo.SetText("");
                txtDockCodeInput.SetText("");
                txtDockCodeInput.Focus();
            }
            else {
                $.ajax({
                    type: "POST",
                    url: "@Url.Content("~/DCLReceiving/CheckDeliveryData")",
                    dataType: "text",
                    data: {
                        txtDeliveryNo: txtDeliveryNo.GetText(),
                        txtDockCode: txtDockCodeInput.GetText()
                    },
                    success: function (result) {
                        if (result != null && result != " ") {
                            if (result == "0") {
                                document.getElementById("lblErrorMessage").innerHTML = 'Data is not exists, please check your DeliveryNo or DockCode!!';
                                soundManager.setup(
                                {
                                    url: 'Content/swf/soundmanager2.swf',
                                    onready: function () {
                                        var myFailure = soundManager.createSound({
                                            id: 'myFailure',
                                            url: 'Content/Sounds/Failure.mp3'
                                        });

                                        myFailure.play();
                                    }
                                });
                                txtDeliveryNo.SetText("");
                                txtDockCodeInput.SetText("");
                            }
                            else if (result == "3") {
                                document.getElementById("lblErrorMessage").innerHTML = 'Tracking Point doesnt exists';
                                soundManager.setup(
                                {
                                    url: 'Content/swf/soundmanager2.swf',
                                    onready: function () {
                                        var myFailure = soundManager.createSound({
                                            id: 'myFailure',
                                            url: 'Content/Sounds/Failure.mp3'
                                        });

                                        myFailure.play();
                                    }
                                });
                                txtDeliveryNo.SetText("");
                                txtDockCodeInput.SetText("");
                            }
                            else if (result == "4") {
                                document.getElementById("lblErrorMessage").innerHTML = 'Tracking Point already scanned';
                                txtDeliveryNo.SetText("");
                                txtDockCodeInput.SetText("");
                            }
                            // Added by WOT, 23/6/2015 [start]
                            else if (result.indexOf("##TCS_ERROR##") == 0) {
                                document.getElementById("lblErrorMessage").innerHTML = result.replace("##TCS_ERROR##", "");
                                soundManager.setup(
                                {
                                    url: 'Content/swf/soundmanager2.swf',
                                    onready: function () {
                                        var myFailure = soundManager.createSound({
                                            id: 'myFailure',
                                            url: 'Content/Sounds/Failure.mp3'
                                        });

                                        myFailure.play();
                                    }
                                });
                                txtDeliveryNo.SetText("");
                                txtDockCodeInput.SetText("");
                                txtDockCodeInput.Focus();
                            }
                            // Added by WOT, 23/6/2015 [end]
                            else {
                                if (result.substring(0, 4) == "Error") {
                                    document.getElementById("lblErrorMessage").innerHTML = result;
                                    soundManager.setup(
                                    {
                                        url: 'Content/swf/soundmanager2.swf',
                                        onready: function () {
                                            var myFailure = soundManager.createSound({
                                                id: 'myFailure',
                                                url: 'Content/Sounds/Failure.mp3'
                                            });

                                            myFailure.play();
                                        }
                                    });
                                    txtDeliveryNo.SetText("");
                                    txtDockCodeInput.SetText("");
                                    txtDockCodeInput.Focus();
                                }
                                else {
                                    if (result == "1") document.getElementById("lblErrorMessage").innerHTML = 'Gap between Scan Arrival and Departure is 2 minutes, please wait!!';
                                    else if (result == "2") document.getElementById("lblErrorMessage").innerHTML = 'Already scanned';

                                    BeginToSubmit2();
                                }
                            }
                        }
                        else {
                            BeginToSubmit();
                        }
                    },
                    error: ajaxError
                });
                txtDockCodeInput.Focus();
            }
        }
    }

    function BeginToSubmit(s, e) {
        $.ajax({
            type: "POST",
            url: "@Url.Content("~/DCLReceiving/ModifReceivingData")",
            dataType: "text",
            data: {
                txtDeliveryNo: txtDeliveryNo.GetText(),
                txtDockCode: txtDockCodeInput.GetText()
            },
            success: function (result) {
                if (result != null && result != "") {
                    if (result == "2") txtDockCodeInput.Focus();

                    if (result == "3") {
                        clearTruckArrivalInfo();
                        document.getElementById("lblErrorMessage").innerHTML = 'Delivery No Already Delivered';
                        txtDeliveryNo.SetText("");
                        txtDockCodeInput.SetText("");
                    }
                    else {
                        BeginToSubmit2();
                    }
                }
                else {
                    clearTruckArrivalInfo();
                    document.getElementById("lblErrorMessage").innerHTML = 'Scan waiting area successfull';
                    txtDeliveryNo.SetText("");
                    txtDockCodeInput.SetText("");
                }
            },
            error: ajaxError
        });
    }

    function BeginToSubmit2(s, e) {

        $.ajax({
            type: "POST",
            url: "@Url.Content("~/DCLReceiving/GetReceivingData")",
            data: {
                txtDeliveryNo: txtDeliveryNo.GetText(),
                txtDockCode: txtDockCodeInput.GetText()
            },
            success: function (result) {
                $("#theresult").html(result);
                txtDeliveryNo.SetText("");
                txtDockCodeInput.SetText("");

                if (document.getElementById("lblErrorMessage").innerHTML == "Gap between Scan Arrival and Departure is 2 minutes, please wait!!" ||
                    document.getElementById("lblErrorMessage").innerHTML == "Already scanned") {
                    soundManager.setup(
                                 {
                                     url: 'Content/swf/soundmanager2.swf',
                                     onready: function () {
                                         var mySoundDoubleScan = soundManager.createSound({
                                             id: 'mySoundDoubleScan',
                                             url: 'Content/Sounds/Double Scan.mp3'
                                         });

                                         mySoundDoubleScan.play();
                                     }
                                 });
                }
                else {
                    if (document.getElementById("lblArrivalInfo").innerHTML != "" && document.getElementById("lblDepartureInfo").innerHTML == "None") {
                        if (document.getElementById("lblArrivalInfo").innerHTML == "Delay") {
                            soundManager.setup(
                            {
                                url: 'Content/swf/soundmanager2.swf',
                                onready: function () {
                                    var mySound = soundManager.createSound({
                                        id: 'mySound',
                                        url: 'Content/Sounds/ARV Delay.mp3'
                                    });

                                    mySound.play();
                                }
                            });
                        }
                        else if (document.getElementById("lblArrivalInfo").innerHTML == "OnTime") {
                            soundManager.setup(
                            {
                                url: 'Content/swf/soundmanager2.swf',
                                onready: function () {
                                    var mySound2 = soundManager.createSound({
                                        id: 'mySound2',
                                        url: 'Content/Sounds/ARV OnTime.mp3'
                                    });

                                    mySound2.play();
                                }
                            });
                        }
                    }
                    else if (document.getElementById("lblArrivalInfo").innerHTML != "None" && document.getElementById("lblDepartureInfo").innerHTML != "") {
                        if (document.getElementById("lblDepartureInfo").innerHTML == "Delay") {
                            soundManager.setup(
                            {
                                url: 'Content/swf/soundmanager2.swf',
                                onready: function () {
                                    var mySound3 = soundManager.createSound({
                                        id: 'mySound3',
                                        url: 'Content/Sounds/DPT Delay.mp3'
                                    });

                                    mySound3.play();
                                }
                            });
                        }
                        else if (document.getElementById("lblDepartureInfo").innerHTML == "OnTime") {
                            soundManager.setup(
                            {
                                url: 'Content/swf/soundmanager2.swf',
                                onready: function () {
                                    var mySound4 = soundManager.createSound({
                                        id: 'mySound4',
                                        url: 'Content/Sounds/DPT OnTime.mp3'
                                    });

                                    mySound4.play();
                                }
                            });
                        }
                    }
                }

                if (timer != null) {
                    window.clearTimeout(timer);
                }

                timer = window.setTimeout(function () {
                    document.getElementById("lblErrorMessage").innerHTML = ' ';
                    clearTruckArrivalInfo();
                    txtDockCodeInput.SetText('');
                    txtDeliveryNo.SetText('');
                    txtDockCodeInput.Focus();
                    timer = null;
                }, 60000);
            },
            error: ajaxError
        });
    }

    function OnKeyDownDeliveryNo(s, e) {
        if (e.htmlEvent.keyCode == ASPxKey.Enter) {
            btnReceive.DoClick();
            return ASPxClientUtils.PreventEventAndBubble(e.htmlEvent);
        }
    }

    function OnKeyDownDockCode(s, e) {
        if (e.htmlEvent.keyCode == ASPxKey.Enter) {
            txtDeliveryNo.Focus();
            //$('#txtDeliveryNo').focus();
            return ASPxClientUtils.PreventEventAndBubble(e.htmlEvent);
        }
    }

    function filteringdata(s, e) {
        DeliveryNo = txtDeliveryNo.GetText();
        Arrival_Plan_Dt = txtArrivalPlan.GetText();
        Arrival_Actual_Dt = txtArrivalActual.GetText();
        Arrival_Gap = txtArrivalGap.GetText();
        Departure_Actual_Dt = txtDepartureActual.GetText();
        Departure_Plan_Dt = txtDeparturePlan.GetText();
        Departure_Gap = txtDepartureGap.GetText();
    }

    function clearTruckArrivalInfo() {
        document.getElementById("lblTS").innerHTML = '';
        document.getElementById("lblDock").innerHTML = '';
        document.getElementById("lblRemainingTime").innerHTML = '';
        document.getElementById("lblTime").innerHTML = '';
        document.getElementById("ROUTE").innerHTML = '';
        document.getElementById("lblRate").innerHTML = '';
        document.getElementById("lblReviseNo").innerHTML = '0';
        txtArrivalPlan.SetText('');
        txtArrivalActual.SetText('');
        txtArrivalGap.SetText('');
        document.getElementById("lblArrivalInfo").innerHTML = '';
        txtDeparturePlan.SetText('');
        txtDepartureActual.SetText('');
        txtDepartureGap.SetText('');
        document.getElementById("lblDepartureInfo").innerHTML = '';
        $('#imgArrival').attr('src', 'Content/Images/biggraydot2.jpg');
        $('#imgDeparture').attr('src', 'Content/Images/biggraydot2.jpg');
        document.getElementById("lblErrorMessage").innerHTML = ' ';
    }

</script>
<table width="100%" border="0" cellpadding="1" cellspacing="1">
    <tr>
        <td style="width:30%; vertical-align:top; border:10px; padding-right:10px;">
            <div style="border:1px solid  #4f93e3; background-color:#DEECFD;">
                @{
                    Html.RenderAction("DCLScanBarcodePartial", "DCLReceiving");
                }
            </div>
            <br />
            <div style="float:left; padding-top:2px; padding-left:2px">
                @Html.DevExpress().Label(
                    settings =>
                    {
                        settings.Name = "lblErrorMessage";
                        settings.ControlStyle.ForeColor=System.Drawing.Color.Red;
                        settings.ControlStyle.Font.Bold=true;
                        settings.ControlStyle.Font.Size=15;
                        settings.Height = Unit.Pixel(50);
                        settings.Width = Unit.Percentage(100);
                    }
                ).GetHtml()
            </div>
        </td>
        <td style="width:70%">
                @{
                    Html.RenderAction("PartialDetilRecevingMores", "DCLReceiving");
                }
        </td>        
    </tr>
</table>